unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls, dsLeds;

type
  TForm1 = class(TForm)
    SpinEdit1: TSpinEdit;
    Button1: TButton;
    Button2: TButton;
    dsLed1: TdsLed;
    dsSevenSegmentDisplay1: TdsSevenSegmentDisplay;
    dsDotMatrixDisplay1: TdsDotMatrixDisplay;
    procedure SpinEdit1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  case StrToInt(SpinEdit1.Text) of
    1: begin
         dsSevenSegmentDisplay1.Segments := [tsUpperRight, tsLowerRight];
         dsDotMatrixDisplay1.Dots := '00100011000010000100001000010001110';
       end;
    2: begin
         dsSevenSegmentDisplay1.Segments := [tsTop, tsUpperRight, tsMiddle, tsLowerLeft, tsBottom];
         dsDotMatrixDisplay1.ExtSetDots([2,3,4,6,10,15,19,23,27,31,32,33,34,35]);
       end;
    3: begin
         dsSevenSegmentDisplay1.Segments := [tsTop, tsUpperRight, tsMiddle, tsLowerRight, tsBottom];
         dsDotMatrixDisplay1.ExtSetDots([1,2,3,4,5,9,13,19,25,26,30,32,33,34]);
       end;
    4: begin
         dsSevenSegmentDisplay1.Segments := [tsUpperLeft, tsUpperRight, tsMiddle, tsLowerRight];
         dsDotMatrixDisplay1.ExtSetDots([4,8,9,12,14,16,19,21,22,23,24,25,29,34]);
       end;
    5: begin
         dsSevenSegmentDisplay1.Segments := [tsTop, tsUpperLeft, tsMiddle, tsLowerRight, tsBottom];
         dsDotMatrixDisplay1.ExtSetDots([1,2,3,4,5,6,11,12,13,14,20,25,26,30,32,33,34]);
       end;
    6: begin
         dsSevenSegmentDisplay1.Segments := [tsTop, tsUpperLeft, tsMiddle, tsLowerLeft, tsLowerRight, tsBottom];
         dsDotMatrixDisplay1.ExtSetDots([3,4,7,11,16,17,18,19,21,25,26,30,32,33,34]);
       end;
    7: begin
         dsSevenSegmentDisplay1.Segments := [tsTop, tsUpperRight, tsLowerRight];
         dsDotMatrixDisplay1.ExtSetDots([1,2,3,4,5,10,14,19,23,28,33]);
       end;
    8: begin
         dsSevenSegmentDisplay1.Segments := [tsTop, tsUpperLeft, tsUpperRight, tsMiddle, tsLowerLeft, tsLowerRight, tsBottom];
         dsDotMatrixDisplay1.ExtSetDots([2,3,4,6,10,11,15,17,18,19,21,25,26,30,32,33,34]);
       end;
    9: begin
         dsSevenSegmentDisplay1.Segments := [tsTop, tsUpperLeft, tsUpperRight, tsMiddle, tsLowerRight, tsBottom];
         dsDotMatrixDisplay1.ExtSetDots([2,3,4,6,10,11,15,17,18,19,20,25,29,32,33]);
       end;
    0: begin
         dsSevenSegmentDisplay1.Segments := [tsTop, tsUpperLeft, tsUpperRight, tsLowerLeft, tsLowerRight, tsBottom];
         dsDotMatrixDisplay1.ExtSetDots([2,3,4,6,10,11,15,16,20,21,25,26,30,32,33,34]);
       end;
    else
       begin
         dsSevenSegmentDisplay1.Segments := [tsTop, tsUpperLeft, tsMiddle, tsLowerLeft, tsBottom];
         dsDotMatrixDisplay1.ExtSetDots([1,2,3,5,9,14,18,22,32]);
       end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  dsLed1.LedOn := not dsLed1.LedOn;
end;

procedure TForm1.Button2Click(Sender: TObject);
{
var
  i: Integer;
  tmpDots: TdsDisplayDots;
  EditorForm: TDotMatrixEditorForm;
}
begin
{
  EditorForm := TDotMatrixEditorForm.Create(Application);
  try
    with EditorForm do
    begin
      OnColor := dsDotMatrixDisplay1.OnColor;
      OffColor := dsDotMatrixDisplay1.OffColor;

      //set dots
      for i := 0 to ComponentCount - 1 do
        if Components[i] is TShape then
        begin
          TShape(Components[i]).Pen.Color := dsDotMatrixDisplay1.BackColor;
          if dsDotMatrixDisplay1.Dots[TShape(Components[i]).Tag] = '1' then
            TShape(Components[i]).Brush.Color := OnColor
          else
            TShape(Components[i]).Brush.Color := OffColor;
        end;

      tmpDots := StringOfChar('0', 35);

      if ShowModal = mrOk then
      begin
        //set display
        for i := 0 to ComponentCount - 1 do
          if Components[i] is TShape then
            if TShape(Components[i]).Brush.Color = OnColor then tmpDots[TShape(Components[i]).Tag] := '1';
        dsDotMatrixDisplay1.Dots := tmpDots;
      end;
    end;
  finally
    EditorForm.Free;
  end;
}  
end;

end.
