unit dsDotMatrixDisplayEditor;

interface

uses
  Windows, Controls, StdCtrls, Classes, Forms, ExtCtrls,
  dialogs, buttons, SysUtils, Graphics, dsLeds;

type
  TDotMatrixEditorForm = class(TForm)
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    Shape7: TShape;
    Shape8: TShape;
    Shape9: TShape;
    Shape10: TShape;
    Shape11: TShape;
    Shape12: TShape;
    Shape13: TShape;
    Shape14: TShape;
    Shape15: TShape;
    Shape16: TShape;
    Shape17: TShape;
    Shape18: TShape;
    Shape19: TShape;
    Shape20: TShape;
    Shape21: TShape;
    Shape22: TShape;
    Shape23: TShape;
    Shape24: TShape;
    Shape25: TShape;
    Shape26: TShape;
    Shape27: TShape;
    Shape28: TShape;
    Shape29: TShape;
    Shape30: TShape;
    Shape31: TShape;
    Shape32: TShape;
    Shape33: TShape;
    Shape34: TShape;
    Shape35: TShape;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure Shape1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

  public
    OnColor: TColor;
    OffColor: TColor;
  end;

  TdsDotMatrixDisplayEditor = class(TDefaultEditor)
  public
    function GetVerb(Index: Integer): String; override;
    function GetVerbCount: Integer; override;
    procedure ExecuteVerb(Index: Integer); override;
  end;

procedure Register;

implementation

{$R *.DFM}

function TdsDotMatrixDisplayEditor.GetVerb(Index: Integer): String;
begin
  case Index of
    0: Result := 'Dots E&ditor...';
  end;
end;

function TdsDotMatrixDisplayEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

procedure TdsDotMatrixDisplayEditor.ExecuteVerb(Index: Integer);
var
  i: Integer;
  tmpDots: TdsDisplayDots;
  EditorForm: TDotMatrixEditorForm;
begin
  inherited;

  case Index of
    0:
      begin
        EditorForm := TDotMatrixEditorForm.Create(Application);
        try
          with EditorForm do
          begin
            OnColor := TdsDotMatrixDisplay(Component).OnColor;
            OffColor := TdsDotMatrixDisplay(Component).OffColor;

            //set dots
            for i := 0 to ComponentCount - 1 do
              if Components[i] is TShape then
              begin
                TShape(Components[i]).Pen.Color := TdsDotMatrixDisplay(Component).BackColor;
                if TdsDotMatrixDisplay(Component).Dots[TShape(Components[i]).Tag] = '1' then
                  TShape(Components[i]).Brush.Color := OnColor
                else
                  TShape(Components[i]).Brush.Color := OffColor;
              end;

            tmpDots := StringOfChar('0', 35);

            if ShowModal = mrOk then
            begin
              //set display
              for i := 0 to ComponentCount - 1 do
                if Components[i] is TShape then
                  if TShape(Components[i]).Brush.Color = OnColor then tmpDots[TShape(Components[i]).Tag] := '1';
              TdsDotMatrixDisplay(Component).Dots := tmpDots;
            end;
          end;
        finally
          EditorForm.Free;
        end;
      end;
    end;
end;

procedure TDotMatrixEditorForm.Shape1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if TShape(Sender).Brush.Color = OnColor then
    TShape(Sender).Brush.Color := OffColor
  else
    TShape(Sender).Brush.Color := OnColor;
end;



procedure Register;
begin
  RegisterComponentEditor(TdsDotMatrixDisplay, TdsDotMatrixDisplayEditor);
end;

end.
